//
//
//
//
//
var script = {
  props: {
    width: {
      type: Number,
      required: true
    },
    order: {
      type: Number,
      default: 0
    }
  },

  data() {
    return {
      height: 0,
      style: null
    };
  },

  created() {
    this.$nextTick(() => {
      this.height = this.$el.clientHeight;
      this.notify();
    });
  },

  mounted() {},

  methods: {
    notify() {
      this.$emit('reflow', this);
    },

    getMeta() {
      return {
        vm: this,
        node: this.$el,
        order: this.order,
        width: this.width,
        isWholeGrid: this.isWholeGrid,
        height: this.height,
        moveClass: this.moveClass
      };
    }

  }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
/* server only */
, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
  if (typeof shadowMode !== 'boolean') {
    createInjectorSSR = createInjector;
    createInjector = shadowMode;
    shadowMode = false;
  } // Vue.extend constructor export interop.


  const options = typeof script === 'function' ? script.options : script; // render functions

  if (template && template.render) {
    options.render = template.render;
    options.staticRenderFns = template.staticRenderFns;
    options._compiled = true; // functional template

    if (isFunctionalTemplate) {
      options.functional = true;
    }
  } // scopedId


  if (scopeId) {
    options._scopeId = scopeId;
  }

  let hook;

  if (moduleIdentifier) {
    // server build
    hook = function (context) {
      // 2.3 injection
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
      // 2.2 with runInNewContext: true

      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__;
      } // inject component styles


      if (style) {
        style.call(this, createInjectorSSR(context));
      } // register component module identifier for async chunk inference


      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    }; // used by ssr in case component is cached and beforeCreate
    // never gets called


    options._ssrRegister = hook;
  } else if (style) {
    hook = shadowMode ? function (context) {
      style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
    } : function (context) {
      style.call(this, createInjector(context));
    };
  }

  if (hook) {
    if (options.functional) {
      // register for functional component in vue file
      const originalRender = options.render;

      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      // inject component registration as beforeCreate hook
      const existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }

  return script;
}

const isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());

function createInjector(context) {
  return (id, style) => addStyle(id, style);
}

let HEAD;
const styles = {};

function addStyle(id, css) {
  const group = isOldIE ? css.media || 'default' : id;
  const style = styles[group] || (styles[group] = {
    ids: new Set(),
    styles: []
  });

  if (!style.ids.has(id)) {
    style.ids.add(id);
    let code = css.source;

    if (css.map) {
      // https://developer.chrome.com/devtools/docs/javascript-debugging
      // this makes source maps inside style tags work properly in Chrome
      code += '\n/*# sourceURL=' + css.map.sources[0] + ' */'; // http://stackoverflow.com/a/26603875

      code += '\n/*# sourceMappingURL=data:application/json;base64,' + btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) + ' */';
    }

    if (!style.element) {
      style.element = document.createElement('style');
      style.element.type = 'text/css';
      if (css.media) style.element.setAttribute('media', css.media);

      if (HEAD === undefined) {
        HEAD = document.head || document.getElementsByTagName('head')[0];
      }

      HEAD.appendChild(style.element);
    }

    if ('styleSheet' in style.element) {
      style.styles.push(code);
      style.element.styleSheet.cssText = style.styles.filter(Boolean).join('\n');
    } else {
      const index = style.ids.size - 1;
      const textNode = document.createTextNode(code);
      const nodes = style.element.childNodes;
      if (nodes[index]) style.element.removeChild(nodes[index]);
      if (nodes.length) style.element.insertBefore(textNode, nodes[index]);else style.element.appendChild(textNode);
    }
  }
}

/* script */
const __vue_script__ = script;

/* template */
var __vue_render__ = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"vue-masonry-slot",style:([_vm.style ? Object.assign({}, _vm.style) : {'width': _vm.width + 'px'}])},[_vm._t("default")],2)};
var __vue_staticRenderFns__ = [];

  /* style */
  const __vue_inject_styles__ = function (inject) {
    if (!inject) return
    inject("data-v-6b1d1217_0", { source: ".vue-masonry-slot[data-v-6b1d1217]{position:absolute;top:0;left:0;margin:0;padding:0;opacity:0;box-sizing:border-box;transform:translate(0,0)}", map: undefined, media: undefined });

  };
  /* scoped */
  const __vue_scope_id__ = "data-v-6b1d1217";
  /* module identifier */
  const __vue_module_identifier__ = undefined;
  /* functional template */
  const __vue_is_functional_template__ = false;
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__ = normalizeComponent(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    false,
    createInjector,
    undefined,
    undefined
  );

function compileSearch(funcName, predicate, reversed, extraArgs, useNdarray, earlyOut) {
  var code = ["function ", funcName, "(a,l,h,", extraArgs.join(","), "){", earlyOut ? "" : "var i=", reversed ? "l-1" : "h+1", ";while(l<=h){\
var m=(l+h)>>>1,x=a", useNdarray ? ".get(m)" : "[m]"];

  if (earlyOut) {
    if (predicate.indexOf("c") < 0) {
      code.push(";if(x===y){return m}else if(x<=y){");
    } else {
      code.push(";var p=c(x,y);if(p===0){return m}else if(p<=0){");
    }
  } else {
    code.push(";if(", predicate, "){i=m;");
  }

  if (reversed) {
    code.push("l=m+1}else{h=m-1}");
  } else {
    code.push("h=m-1}else{l=m+1}");
  }

  code.push("}");

  if (earlyOut) {
    code.push("return -1};");
  } else {
    code.push("return i};");
  }

  return code.join("");
}

function compileBoundsSearch(predicate, reversed, suffix, earlyOut) {
  var result = new Function([compileSearch("A", "x" + predicate + "y", reversed, ["y"], false, earlyOut), compileSearch("B", "x" + predicate + "y", reversed, ["y"], true, earlyOut), compileSearch("P", "c(x,y)" + predicate + "0", reversed, ["y", "c"], false, earlyOut), compileSearch("Q", "c(x,y)" + predicate + "0", reversed, ["y", "c"], true, earlyOut), "function dispatchBsearch", suffix, "(a,y,c,l,h){\
if(a.shape){\
if(typeof(c)==='function'){\
return Q(a,(l===undefined)?0:l|0,(h===undefined)?a.shape[0]-1:h|0,y,c)\
}else{\
return B(a,(c===undefined)?0:c|0,(l===undefined)?a.shape[0]-1:l|0,y)\
}}else{\
if(typeof(c)==='function'){\
return P(a,(l===undefined)?0:l|0,(h===undefined)?a.length-1:h|0,y,c)\
}else{\
return A(a,(c===undefined)?0:c|0,(l===undefined)?a.length-1:l|0,y)\
}}}\
return dispatchBsearch", suffix].join(""));
  return result();
}

var searchBounds = {
  ge: compileBoundsSearch(">=", false, "GE"),
  gt: compileBoundsSearch(">", false, "GT"),
  lt: compileBoundsSearch("<", true, "LT"),
  le: compileBoundsSearch("<=", true, "LE"),
  eq: compileBoundsSearch("-", true, "EQ", true)
};

var NOT_FOUND = 0;
var SUCCESS = 1;
var EMPTY = 2;
var intervalTree = createWrapper;

function IntervalTreeNode(mid, left, right, leftPoints, rightPoints) {
  this.mid = mid;
  this.left = left;
  this.right = right;
  this.leftPoints = leftPoints;
  this.rightPoints = rightPoints;
  this.count = (left ? left.count : 0) + (right ? right.count : 0) + leftPoints.length;
}

var proto = IntervalTreeNode.prototype;

function copy(a, b) {
  a.mid = b.mid;
  a.left = b.left;
  a.right = b.right;
  a.leftPoints = b.leftPoints;
  a.rightPoints = b.rightPoints;
  a.count = b.count;
}

function rebuild(node, intervals) {
  var ntree = createIntervalTree(intervals);
  node.mid = ntree.mid;
  node.left = ntree.left;
  node.right = ntree.right;
  node.leftPoints = ntree.leftPoints;
  node.rightPoints = ntree.rightPoints;
  node.count = ntree.count;
}

function rebuildWithInterval(node, interval) {
  var intervals = node.intervals([]);
  intervals.push(interval);
  rebuild(node, intervals);
}

function rebuildWithoutInterval(node, interval) {
  var intervals = node.intervals([]);
  var idx = intervals.indexOf(interval);

  if (idx < 0) {
    return NOT_FOUND;
  }

  intervals.splice(idx, 1);
  rebuild(node, intervals);
  return SUCCESS;
}

proto.intervals = function (result) {
  result.push.apply(result, this.leftPoints);

  if (this.left) {
    this.left.intervals(result);
  }

  if (this.right) {
    this.right.intervals(result);
  }

  return result;
};

proto.insert = function (interval) {
  var weight = this.count - this.leftPoints.length;
  this.count += 1;

  if (interval[1] < this.mid) {
    if (this.left) {
      if (4 * (this.left.count + 1) > 3 * (weight + 1)) {
        rebuildWithInterval(this, interval);
      } else {
        this.left.insert(interval);
      }
    } else {
      this.left = createIntervalTree([interval]);
    }
  } else if (interval[0] > this.mid) {
    if (this.right) {
      if (4 * (this.right.count + 1) > 3 * (weight + 1)) {
        rebuildWithInterval(this, interval);
      } else {
        this.right.insert(interval);
      }
    } else {
      this.right = createIntervalTree([interval]);
    }
  } else {
    var l = searchBounds.ge(this.leftPoints, interval, compareBegin);
    var r = searchBounds.ge(this.rightPoints, interval, compareEnd);
    this.leftPoints.splice(l, 0, interval);
    this.rightPoints.splice(r, 0, interval);
  }
};

proto.remove = function (interval) {
  var weight = this.count - this.leftPoints;

  if (interval[1] < this.mid) {
    if (!this.left) {
      return NOT_FOUND;
    }

    var rw = this.right ? this.right.count : 0;

    if (4 * rw > 3 * (weight - 1)) {
      return rebuildWithoutInterval(this, interval);
    }

    var r = this.left.remove(interval);

    if (r === EMPTY) {
      this.left = null;
      this.count -= 1;
      return SUCCESS;
    } else if (r === SUCCESS) {
      this.count -= 1;
    }

    return r;
  } else if (interval[0] > this.mid) {
    if (!this.right) {
      return NOT_FOUND;
    }

    var lw = this.left ? this.left.count : 0;

    if (4 * lw > 3 * (weight - 1)) {
      return rebuildWithoutInterval(this, interval);
    }

    var r = this.right.remove(interval);

    if (r === EMPTY) {
      this.right = null;
      this.count -= 1;
      return SUCCESS;
    } else if (r === SUCCESS) {
      this.count -= 1;
    }

    return r;
  } else {
    if (this.count === 1) {
      if (this.leftPoints[0] === interval) {
        return EMPTY;
      } else {
        return NOT_FOUND;
      }
    }

    if (this.leftPoints.length === 1 && this.leftPoints[0] === interval) {
      if (this.left && this.right) {
        var p = this;
        var n = this.left;

        while (n.right) {
          p = n;
          n = n.right;
        }

        if (p === this) {
          n.right = this.right;
        } else {
          var l = this.left;
          var r = this.right;
          p.count -= n.count;
          p.right = n.left;
          n.left = l;
          n.right = r;
        }

        copy(this, n);
        this.count = (this.left ? this.left.count : 0) + (this.right ? this.right.count : 0) + this.leftPoints.length;
      } else if (this.left) {
        copy(this, this.left);
      } else {
        copy(this, this.right);
      }

      return SUCCESS;
    }

    for (var l = searchBounds.ge(this.leftPoints, interval, compareBegin); l < this.leftPoints.length; ++l) {
      if (this.leftPoints[l][0] !== interval[0]) {
        break;
      }

      if (this.leftPoints[l] === interval) {
        this.count -= 1;
        this.leftPoints.splice(l, 1);

        for (var r = searchBounds.ge(this.rightPoints, interval, compareEnd); r < this.rightPoints.length; ++r) {
          if (this.rightPoints[r][1] !== interval[1]) {
            break;
          } else if (this.rightPoints[r] === interval) {
            this.rightPoints.splice(r, 1);
            return SUCCESS;
          }
        }
      }
    }

    return NOT_FOUND;
  }
};

function reportLeftRange(arr, hi, cb) {
  for (var i = 0; i < arr.length && arr[i][0] <= hi; ++i) {
    var r = cb(arr[i]);

    if (r) {
      return r;
    }
  }
}

function reportRightRange(arr, lo, cb) {
  for (var i = arr.length - 1; i >= 0 && arr[i][1] >= lo; --i) {
    var r = cb(arr[i]);

    if (r) {
      return r;
    }
  }
}

function reportRange(arr, cb) {
  for (var i = 0; i < arr.length; ++i) {
    var r = cb(arr[i]);

    if (r) {
      return r;
    }
  }
}

proto.queryPoint = function (x, cb) {
  if (x < this.mid) {
    if (this.left) {
      var r = this.left.queryPoint(x, cb);

      if (r) {
        return r;
      }
    }

    return reportLeftRange(this.leftPoints, x, cb);
  } else if (x > this.mid) {
    if (this.right) {
      var r = this.right.queryPoint(x, cb);

      if (r) {
        return r;
      }
    }

    return reportRightRange(this.rightPoints, x, cb);
  } else {
    return reportRange(this.leftPoints, cb);
  }
};

proto.queryInterval = function (lo, hi, cb) {
  if (lo < this.mid && this.left) {
    var r = this.left.queryInterval(lo, hi, cb);

    if (r) {
      return r;
    }
  }

  if (hi > this.mid && this.right) {
    var r = this.right.queryInterval(lo, hi, cb);

    if (r) {
      return r;
    }
  }

  if (hi < this.mid) {
    return reportLeftRange(this.leftPoints, hi, cb);
  } else if (lo > this.mid) {
    return reportRightRange(this.rightPoints, lo, cb);
  } else {
    return reportRange(this.leftPoints, cb);
  }
};

function compareNumbers(a, b) {
  return a - b;
}

function compareBegin(a, b) {
  var d = a[0] - b[0];

  if (d) {
    return d;
  }

  return a[1] - b[1];
}

function compareEnd(a, b) {
  var d = a[1] - b[1];

  if (d) {
    return d;
  }

  return a[0] - b[0];
}

function createIntervalTree(intervals) {
  if (intervals.length === 0) {
    return null;
  }

  var pts = [];

  for (var i = 0; i < intervals.length; ++i) {
    pts.push(intervals[i][0], intervals[i][1]);
  }

  pts.sort(compareNumbers);
  var mid = pts[pts.length >> 1];
  var leftIntervals = [];
  var rightIntervals = [];
  var centerIntervals = [];

  for (var i = 0; i < intervals.length; ++i) {
    var s = intervals[i];

    if (s[1] < mid) {
      leftIntervals.push(s);
    } else if (mid < s[0]) {
      rightIntervals.push(s);
    } else {
      centerIntervals.push(s);
    }
  } //Split center intervals


  var leftPoints = centerIntervals;
  var rightPoints = centerIntervals.slice();
  leftPoints.sort(compareBegin);
  rightPoints.sort(compareEnd);
  return new IntervalTreeNode(mid, createIntervalTree(leftIntervals), createIntervalTree(rightIntervals), leftPoints, rightPoints);
} //User friendly wrapper that makes it possible to support empty trees


function IntervalTree(root) {
  this.root = root;
}

var tproto = IntervalTree.prototype;

tproto.insert = function (interval) {
  if (this.root) {
    this.root.insert(interval);
  } else {
    this.root = new IntervalTreeNode(interval[0], null, null, [interval], [interval]);
  }
};

tproto.remove = function (interval) {
  if (this.root) {
    var r = this.root.remove(interval);

    if (r === EMPTY) {
      this.root = null;
    }

    return r !== NOT_FOUND;
  }

  return false;
};

tproto.queryPoint = function (p, cb) {
  if (this.root) {
    return this.root.queryPoint(p, cb);
  }
};

tproto.queryInterval = function (lo, hi, cb) {
  if (lo <= hi && this.root) {
    return this.root.queryInterval(lo, hi, cb);
  }
};

Object.defineProperty(tproto, "count", {
  get: function () {
    if (this.root) {
      return this.root.count;
    }

    return 0;
  }
});
Object.defineProperty(tproto, "intervals", {
  get: function () {
    if (this.root) {
      return this.root.intervals([]);
    }

    return [];
  }
});

function createWrapper(intervals) {
  if (!intervals || intervals.length === 0) {
    return new IntervalTree(null);
  }

  return new IntervalTree(createIntervalTree(intervals));
}

/** @flow */
// Position cache requirements:
//   O(log(n)) lookup of cells to render for a given viewport size
//   O(1) lookup of shortest measured column (so we know when to enter phase 1)
var PositionCache = /** @class */ (function () {
    function PositionCache(context) {
        // Maps cell index to x coordinates for quick lookup.
        this._leftMap = {};
        if (context.intervals) {
            this._intervalTree = intervalTree(context.intervals);
        }
        else {
            this._intervalTree = intervalTree();
        }
        this._columnSizeMap = context.columnSizeMap;
        this._positions = context.positions || [];
    }
    PositionCache.prototype.estimateTotalHeight = function (cellCount, columnCount, defaultCellHeight) {
        var unmeasuredCellCount = cellCount - this.count;
        return this.tallestColumnSize + Math.ceil(unmeasuredCellCount / columnCount) * defaultCellHeight;
    };
    // Render all cells visible within the viewport range defined.
    PositionCache.prototype.range = function (scrollTop, clientHeight, renderCallback) {
        var _this = this;
        this._intervalTree.queryInterval(scrollTop, scrollTop + clientHeight, function (_a) {
            var top = _a[0], _ = _a[1], index = _a[2];
            return renderCallback(index, _this._leftMap[index], top);
        });
    };
    PositionCache.prototype.setPosition = function (index, left, top, height) {
        this._positions.push([left, top]);
        // console.log('_intervalTree', this._intervalTree);
        this._intervalTree.insert([top, top + height, index]);
        var _left = left.toFixed(2);
        this._leftMap[index] = _left;
        var columnSizeMap = this._columnSizeMap;
        var columnHeight = columnSizeMap[_left];
        if (columnHeight === undefined) {
            columnSizeMap[_left] = top + height;
        }
        else {
            columnSizeMap[_left] = Math.max(columnHeight, top + height);
        }
        // console.warn('&&&&&&&&&&', columnSizeMap)
    };
    Object.defineProperty(PositionCache.prototype, "intervals", {
        get: function () {
            return this._intervalTree.intervals;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PositionCache.prototype, "positions", {
        get: function () {
            return this._positions;
        },
        enumerable: true,
        configurable: true
    });
    PositionCache.prototype.getPosition = function (index) {
        return this._positions[index] || null;
    };
    Object.defineProperty(PositionCache.prototype, "count", {
        get: function () {
            return this._intervalTree.count;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PositionCache.prototype, "shortestColumnSize", {
        get: function () {
            var columnSizeMap = this._columnSizeMap;
            var size = 0;
            for (var i in columnSizeMap) {
                var height = columnSizeMap[i];
                size = size === 0 ? height : Math.min(size, height);
            }
            return size;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PositionCache.prototype, "tallestColumnSize", {
        get: function () {
            var columnSizeMap = this._columnSizeMap;
            var size = 0;
            for (var i in columnSizeMap) {
                var height = columnSizeMap[i];
                size = Math.max(size, height);
            }
            return size;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PositionCache.prototype, "nextColumnPosition", {
        // return next column position
        get: function () {
            var columnSizeMap = this._columnSizeMap;
            var top;
            var left;
            for (var i in columnSizeMap) {
                var height = columnSizeMap[i];
                if (typeof top === 'undefined') {
                    top = height;
                    left = i;
                }
                else if (top > height) {
                    top = height;
                    left = i;
                }
            }
            var res = { left: parseFloat(left), top: top };
            return res;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PositionCache.prototype, "columnSizeMap", {
        get: function () {
            return this._columnSizeMap;
        },
        enumerable: true,
        configurable: true
    });
    return PositionCache;
}());

//
var script$1 = {
  components: {
    MasonrySlot: __vue_component__
  },
  props: {
    isUseCrossSideGutter: {
      type: Boolean,
      default: true
    },
    containerWidth: {
      type: Number,
      default: 0
    },
    containerHeight: {
      type: Number,
      default: 0
    },
    defaultHeight: {
      type: Number,
      default: 250
    },
    overscan: {
      type: Number,
      default: 0
    },
    grid: {
      type: Number,
      default: 2
    },
    isUseWindowScroll: {
      type: Boolean,
      default: true
    },
    scrollTop: {
      type: Number,
      default: 0
    },
    list: {
      type: Array,
      required: true
    },
    gutter: {
      type: Number,
      default: 10
    },
    state: {
      type: String,
      default: null
    }
  },

  data() {
    return {
      width: 0,
      startIndex: 0,
      endIndex: 0,
      createdSlots: [],
      outerHeight: 0,
      overscanByPixels: 0,
      isInvalidateCellSizeAfterRender: false,
      positionFromTop: 0
    };
  },

  computed: {
    // scroll position 에 따른 보여질 items
    displayItems() {
      return this.list.filter((item, index) => {
        return index >= this.startIndex && index <= this.endIndex;
      });
    },

    // scrollTop 값 조정
    _scrollTop() {
      if (this.isUseWindowScroll && this.$el) {
        return Math.max(0, this.scrollTop - this.positionFromTop);
      }

      return this.scrollTop;
    },

    outerStyle() {
      return {
        height: this.outerHeight + 'px',
        width: this.containerWidth + 'px'
      };
    }

  },
  watch: {
    list() {
      this.updateDisplayIndex();
    },

    _scrollTop() {
      this.updateDisplayIndex();
    }

  },

  created() {
    this.init();
  },

  mounted() {
    this.updatePositionOffset();
    this.updateDisplayIndex();
  },

  updated() {
    if (this.isInvalidateCellSizeAfterRender) {
      this.updateDisplayIndex();
    }
  },

  methods: {
    init() {
      this.width = this.getWidth(this.containerWidth, this.grid, this.gutter, this.isUseCrossSideGutter);
      this.overscanByPixels = this.overscan + 1;
      let context;

      const _state = this.state ? JSON.parse(this.state) : null;

      if (_state) {
        context = Object.assign({}, _state);
      } else {
        context = {
          columnSizeMap: this.getColumnSizeMap(this.grid, this.width, this.gutter, this.isUseCrossSideGutter)
        };
      }

      this.positionCache = new PositionCache(context);
      this.outerHeight = this.getEstimatedTotalHeight();
      this.$nextTick(() => {
        window.scroll({
          top: _state ? _state.scrollTop : 0,
          left: 0
        });
      });
    },

    getEstimatedTotalHeight() {
      const total = this.list.length;
      return this.positionCache.estimateTotalHeight(total, this.grid, this.defaultHeight);
    },

    updateDisplayIndex() {
      const scrollTop = this._scrollTop;
      let startIndex = this.startIndex;
      let endIndex;

      const _scrollTop = Math.max(0, scrollTop - this.overscanByPixels);

      const _height = this.containerHeight + this.overscanByPixels * 2;

      this.isInvalidateCellSizeAfterRender = true;
      this.positionCache.range(_scrollTop, _height, (index, left, top) => {
        this.isInvalidateCellSizeAfterRender = false;

        if (typeof endIndex === 'undefined') {
          startIndex = index;
          endIndex = index;
        } else {
          startIndex = Math.min(startIndex, index);
          endIndex = Math.max(endIndex, index);
        }
      });
      const measureEndIndex = this.getMeasureEndIndex();

      if (~measureEndIndex) {
        endIndex = measureEndIndex;
      }

      this.startIndex = startIndex;
      this.endIndex = endIndex;
    },

    getMeasureEndIndex() {
      const shortestColumnSize = this.positionCache.shortestColumnSize;
      const displayListCount = this.positionCache.count;
      const listCount = this.list.length; // We need to measure additional cells for this layout

      if (shortestColumnSize < this._scrollTop + this.containerHeight + this.overscanByPixels && displayListCount < listCount) {
        const batchSize = Math.min(listCount - displayListCount, Math.ceil((this._scrollTop + this.containerHeight + this.overscanByPixels - shortestColumnSize) / this.defaultHeight * this.containerWidth / this.width));

        if (batchSize) {
          return displayListCount + batchSize - 1;
        }
      }

      return -1;
    },

    forceRender() {
      const measureEndIndex = this.getMeasureEndIndex();

      if (~measureEndIndex) {
        this.endIndex = measureEndIndex;
      }
    },

    // column width
    getWidth(containerWidth, grid, gutter, isUseCrossSideGutter) {
      let width;

      if (isUseCrossSideGutter) {
        width = (containerWidth - (grid + 1) * gutter) / grid;
      } else {
        width = (containerWidth - gutter * (grid - 1)) / grid;
      }

      return width;
    },

    // column 별 top position map
    getColumnSizeMap(grid, width, gutter, isUseCrossSideGutter) {
      const map = {};

      for (let i = 0; i < grid; ++i) {
        let left;

        if (isUseCrossSideGutter) {
          left = i ? width * i + gutter * (i + 1) : gutter;
        } else {
          left = i ? width * i + gutter * i : 0;
        }

        map[left.toFixed(2)] = 0;
      }

      return map;
    },

    // element offset top position 정의
    updatePositionOffset() {
      if (this.$el) {
        this.positionFromTop = window.pageYOffset + this.$el.getBoundingClientRect().top;
      }
    },

    // from child reflow
    reflow(meta) {
      this.createdSlots.push(meta);
      this.$nextTick(() => {
        if (this.createdSlots.length === 0) {
          return;
        }

        const $items = this.createdSlots;
        this.createdSlots = [];
        const metas = $items.map(slot => slot.getMeta());
        metas.sort((a, b) => a.order - b.order);
        this.calculate(metas);

        if (this.endIndex === this.list.length - 1) {
          this.$emit('reflowed', this);
        } else {
          this.forceRender();
        }
      });
    },

    // child slot style 값 정의
    calculate(metas) {
      metas.forEach(meta => {
        let rect;
        const index = meta.vm.order;

        const _position = this.positionCache.getPosition(index);

        if (!_position) {
          const {
            left,
            top
          } = this.positionCache.nextColumnPosition;
          rect = {
            top,
            left,
            width: this.width,
            height: meta.height
          };
          this.positionCache.setPosition(index, left, top, rect.height);
        } else {
          rect = {
            left: _position[0],
            top: _position[1],
            width: this.width,
            height: meta.height
          };
        }

        meta.vm.style = this.buildStyle(rect);
      });
      this.outerHeight = this.getEstimatedTotalHeight();
    },

    buildStyle(rect) {
      return {
        top: 0,
        left: 0,
        width: rect.width + 'px',
        height: rect.height + 'px',
        transform: `translateX(${rect.left}px) translateY(${rect.top}px)`,
        WebkitTransform: `translateX(${rect.left}px) translateY(${rect.top}px)`,
        opacity: 1
      };
    },

    // for save state
    getState() {
      return JSON.stringify({
        positions: this.positionCache.positions,
        intervals: this.positionCache.intervals,
        columnSizeMap: this.positionCache.columnSizeMap,
        scrollTop: this.scrollTop
      });
    }

  }
};

/* script */
const __vue_script__$1 = script$1;

/* template */
var __vue_render__$1 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"vue-masonry",style:(_vm.outerStyle)},_vm._l((_vm.displayItems),function(item,index){return _c('masonry-slot',{key:_vm.startIndex + index,attrs:{"width":_vm.width,"order":_vm.startIndex + index},on:{"reflow":_vm.reflow}},[_vm._t("cell",null,{"width":_vm.width,"order":_vm.startIndex + index,"item":item,"index":_vm.startIndex + index})],2)}),1)};
var __vue_staticRenderFns__$1 = [];

  /* style */
  const __vue_inject_styles__$1 = function (inject) {
    if (!inject) return
    inject("data-v-521bcc92_0", { source: ".vue-masonry[data-v-521bcc92]{position:relative;will-change:transform}", map: undefined, media: undefined });

  };
  /* scoped */
  const __vue_scope_id__$1 = "data-v-521bcc92";
  /* module identifier */
  const __vue_module_identifier__$1 = undefined;
  /* functional template */
  const __vue_is_functional_template__$1 = false;
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$1 = normalizeComponent(
    { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
    __vue_inject_styles__$1,
    __vue_script__$1,
    __vue_scope_id__$1,
    __vue_is_functional_template__$1,
    __vue_module_identifier__$1,
    false,
    createInjector,
    undefined,
    undefined
  );

export { __vue_component__$1 as Masonry };
